﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.IO;
using System.Data;
using System.Windows.Forms;


namespace KyotoUnivEngHywrExecutionEnvironment
{
    class FileIO
    {
        /// <summary>
        /// パラメタ表の値を読み取る
        /// </summary>
        public ArrayList read_datagrid(DataGridView dataGridView1, int check)
        {
            ArrayList buf_gridview = new ArrayList();

            //columnの数はパラメータ同定の場合のみ2で割る
            int columns;
            if (check == 0)
            {
                columns = dataGridView1.Columns.Count;
            }
            else
            {
                columns = dataGridView1.Columns.Count / 2;
            }

            int rows = dataGridView1.Rows.Count -1;

            for (int r = 0; r < rows; r++)
            {
                for (int c = 0; c < columns; c++)
                {
                    buf_gridview.Add(dataGridView1[c,r].Value);
                }
            }
                
            return buf_gridview;
        }

        /// <summary>
        /// ファイルの読み込み(ファイルの出力でも使う)
        /// </summary>
        /// <param name="filename">読み取るファイルの名前</param>
        /// <param name="check">読み取り:0,出力:1</param>
        /// <param name="model_name_pass">モデル名、パラメタ数、パラメタ名が格納</param>
        /// <returns></returns>
        public ArrayList file_in(string filename, int check, ArrayList model_name_pass)
        {
            ArrayList buf = new ArrayList();
            ArrayList buf_out = new ArrayList(); //ファイル出力時に使う

            System.Xml.XmlTextReader reader = new System.Xml.XmlTextReader(filename);
            while (reader.Read())
            {       
                reader.MoveToContent();
                if (reader.NodeType == System.Xml.XmlNodeType.Element)
                { 
                    if (reader.Name == "CalElement")
                    {
                        string check_model_name = " ";
                        for (int i = 0; i < reader.AttributeCount; i++)
                        {
                            reader.MoveToAttribute(i);
                            if (reader.Name == "Model")
                            {
                                check_model_name = (string)reader.GetAttribute(i);
                            }
                        }
                        if (check_model_name == (string)model_name_pass[0])
                        {
                            //モデル名の取得
                            buf.Add(check_model_name);

                            //ElementNameの取得(汎用性を得るためにfor文で回す)
                            buf.Add((string)reader.GetAttribute(reader.AttributeCount - 1));

                            //パラメータを登録分だけ読み込む
                            int parameter_count = 0;
                            while (parameter_count < (int)model_name_pass[1])
                            {
                                reader.Read();
                                if (reader.Name == "Variable")
                                {
                                    for (int i = 0; i < reader.AttributeCount; i++)
                                    {
                                        reader.MoveToAttribute(i);
                                        if (check < 2 && reader.Name == "Value")
                                        {
                                            ////パラメータの値を格納
                                            buf.Add(reader.GetAttribute(i));

                                            //パラメータの行番号と値を格納                                  
                                            buf_out.Add(reader.LineNumber);
                                            buf_out.Add(reader.GetAttribute(i));

                                        }
                                        //MultiのOutputとInput用
                                        else
                                        {
                                            if ((string)reader.Name == "Key" && model_name_pass[2].ToString() == reader.GetAttribute(i))
                                            {
                                                //変更すべき行番号の格納
                                                buf_out.Add(reader.LineNumber);

                                                for (int j = 0; j < reader.AttributeCount; j++)
                                                {
                                                    reader.MoveToAttribute(j);
                                                    if (reader.Name == "Value")
                                                    {
                                                        //変更すべきディレクトリーの格納
                                                        string[] dummy_out_directry = reader.GetAttribute(j).Split('\\');
                                                        int dummy_out = dummy_out_directry.Count()-1;
                                                        string out_directry = "";
                                                        
                                                        for (int k = 0; k < dummy_out; k++)
                                                        {
                                                            out_directry += dummy_out_directry[k] +"\\";
                                                        }
                                                        buf_out.Add(out_directry);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                
                                    //パラメータのカウントを更新
                                    parameter_count++;                                                             
                                }
                            }
                        }
                    }
                }
                
            }
            reader.Close();

            if (check == 0)
            {
                return buf;
            }
            else
            {
                return buf_out;
            }
        }

        /// <summary>
        /// ファイルの書き出し
        /// </summary>
        /// <param name="filename_in">読み込んだファイルの名前</param>
        /// <param name="filename_out">出力するファイルの名前</param>
        /// <param name="buf_out">更新後のパラメタ名と構造定義ファイル内の行番号</param>
        /// <param name="buf_datagridview">更新前のパラメタ名と構造定義ファイル内の行番号</param>
        /// <param name="model_name_pass">モデル名、パラメタ数、パラメタ名が格納</param>
        /// <returns></returns>
        public bool file_out(string filename_in, string filename_out, ArrayList buf_out, ArrayList buf_datagridview, ArrayList model_name_pass)
        {
          //xml読み込み⇒修正⇒出力
            ArrayList buf = new ArrayList();
            string line;
            using (StreamReader r = new StreamReader(filename_in))
            {
                while ((line = r.ReadLine()) != null)
                {
                    buf.Add(line);
                }
                r.Close();
            }

            using (StreamWriter w = new StreamWriter(filename_out,false,
                System.Text.Encoding.GetEncoding("UTF-8"))) 
            {
                for (int i = 0; i < buf.Count; i++)
                {
                    int change = 0;//書き換える行ならば1になる                                     
                    for (int j = 0; j < buf_out.Count;j+=2)
                    {
                        if (i == (int)buf_out[j] - 1)
                        {
                            //model_name_pass[1]はパラメータの数が格納されている
                            int row = j / (((int)model_name_pass[1])*2);
                            int column = (j - ((int)model_name_pass[1]) * 2 * row) /2 ; //ここの2はパラメータの行と値の2つという意味//(int)model_name_pass[1]
                            int num_buf = row*(int)model_name_pass[1] + column;

                            //xmlファイル内のパラメータを置換するにあたり、パラメータ値のみを置換することが大切。
                            //そのために" Value="で区切りその後のみを置換する形を取る。
                            string[] word = { " Value=" };
                            string[] sep_words = buf[i].ToString().Split(word, StringSplitOptions.None);
                            int sep_words_count = sep_words.Count();

                            sep_words[sep_words_count-1] = sep_words[sep_words_count-1].Replace((string)buf_out[j + 1], (string)buf_datagridview[num_buf]);

                            string change_line = sep_words[0];

                            for (int k = 1; k < sep_words_count; k++)
                            {
                                change_line += " Value=" +sep_words[k];
                            }
                            
                            w.WriteLine(change_line);
                            change = 1;
                        }
                    }
                    if (change == 0)
                    {
                        w.WriteLine(buf[i]);
                    }
                }
                w.Close();
            }

            //Project.xml出力
            string filename_in_pro = filename_in.Replace(".xml", "ProjectFile.xml");
            ArrayList buf_out_pro = new ArrayList();

                        //Project.xmlが存在する時のみ出力する
            if (File.Exists(filename_in_pro))
            {
                //先に読み込んだxmlファイルのProjectファイルを全部コピーする
                using (StreamReader r = new StreamReader(filename_in_pro))
                {
                    while ((line = r.ReadLine()) != null)
                    {
                        buf_out_pro.Add(line);
                    }
                    r.Close();
                }

                //
                //filename_out=出力ファイル名
                string filename_out_pro = filename_out.Replace(".xml", "ProjectFile.xml");
                string[] fop = filename_out.Split('\\', '/');

                using (StreamWriter w = new StreamWriter(filename_out_pro, false,
        System.Text.Encoding.GetEncoding("UTF-8")))
                {
                    for (int i = 0; i < buf_out_pro.Count; i++)
                    {
                        if (i == 2)
                        {
                            string a = "  <SCFile FileName=\"" + fop[fop.Count() - 1] + "\" />";
                            w.WriteLine(a);
                        }
                        else
                        {
                            w.WriteLine(buf_out_pro[i]);
                        }
                    }
                    w.Close();
                }
            }
            return true;
        }

        ArrayList need_element_model_name = new ArrayList();
        ArrayList need_shapeKind_name = new ArrayList();
        ArrayList all_elementname_number = new ArrayList();
        ArrayList component_line = new ArrayList();
        ArrayList all_element_model_name = new ArrayList();
        ArrayList all_para_name = new ArrayList();

        /// <summary>
        /// 要素モデルの名称と種類を抽出
        /// </summary>
        /// <param name="filename">読み込むファイルの名前</param>
        /// <returns></returns>
        public bool check_file(string filename)
        {
            ArrayList all_shapeKind_name = new ArrayList();
            string all_element_model_name_dummy ="";
            string check_model_name = "";    
            string check_ShapeKind = "";
            string check_ElementName = "";  

            //要素モデル名抽出のためにXMLファイルを読む
            try
            {
                System.Xml.XmlTextReader reader_ele = new System.Xml.XmlTextReader(filename);
                while (reader_ele.Read())
                {
                    reader_ele.MoveToContent();

                    check_model_name = reader_ele.Name;

                    for (int i = 0; i < reader_ele.AttributeCount; i++)
                    {
                        reader_ele.MoveToAttribute(i);
                        if (reader_ele.Name == "Model")
                        {
                            all_element_model_name_dummy = reader_ele.GetAttribute(i).ToString();
                        }
                        else if (reader_ele.Name == "ShapeKind")
                        {
                            check_ShapeKind = reader_ele.GetAttribute(i).ToString();
                        }
                        else if (reader_ele.Name == "ElementName")
                        {
                            check_ElementName = reader_ele.GetAttribute(i).ToString();

                            //ElementNameは()内の数字のみ取り出して格納
                            try
                            {
                                string number_dummy = check_ElementName.Split('(', ')')[1];
                                all_elementname_number.Add(int.Parse(number_dummy));
                            }
                            catch
                            {
                                all_elementname_number.Add("Null");
                            }
                        }
                    }

                    //要素モデルの名前を抽出する
                    if (check_model_name == "CalElement")
                    {
                        all_element_model_name.Add(all_element_model_name_dummy);
                        all_shapeKind_name.Add(check_ShapeKind);
                        component_line.Add(reader_ele.LineNumber);
                    }
                }
                reader_ele.Close();
            }
            catch
            {
                MessageBox.Show("","Error");
                goto Finish;
            }

            //構造定義ファイルを読み込んだかをチェック
            if (all_element_model_name.Count == 0)
            {
                goto Finish;
            }

            //要素モデルが被らないように整理する
            need_element_model_name.Add(all_element_model_name[0]);
            need_shapeKind_name.Add(all_shapeKind_name[0]);
            for (int i = 1; i < all_element_model_name.Count; i++)
            {
                for (int j = 0; j < need_element_model_name.Count; j++)
                {
                    if (need_element_model_name[j].ToString() == all_element_model_name[i].ToString())
                    {
                        goto Out;
                    }
                }
                need_element_model_name.Add(all_element_model_name[i]);
                need_shapeKind_name.Add(all_shapeKind_name[i]);
            Out: ;
            }

            //パラメータ名取得のためにXMLファイルを再び読む
            int count = 0;

            System.Xml.XmlTextReader reader_para = new System.Xml.XmlTextReader(filename);
            while (reader_para.Read())
            {
                reader_para.MoveToContent();

                check_model_name = reader_para.Name;

                if (check_model_name == "CalElement")
                {
                    ArrayList pname = new ArrayList();
                    
                    //要素モデル名を読み込み、先に読み込んだ要素モデルのパラメータの名前を読み込む
                    for (int i = 0; i < reader_para.AttributeCount; i++)
                    {
                        reader_para.MoveToAttribute(i);
                        if (reader_para.Name == "Model")
                        {
                            all_element_model_name_dummy = reader_para.GetAttribute(i).ToString();
                        }
                    }

                    if (all_element_model_name_dummy == need_element_model_name[count].ToString())
                    {
                        reader_para.Read();

                        //</CalElement>まで読み続ける
                        while (reader_para.Name != "CalElement")
                        {
                            check_model_name = reader_para.Name;

                            if (check_model_name == "Variable")
                            {
                                for (int i = 0; i < reader_para.AttributeCount; i++)
                                {
                                    reader_para.MoveToAttribute(i);
                                    if (reader_para.Name == "Name")
                                    {
                                        pname.Add(reader_para.GetAttribute(i).ToString());
                                    }
                                }
                            }
                            reader_para.Read();
                        }

                        all_para_name.Add(pname);
                        count++;

                        if (count == need_element_model_name.Count)
                        {
                            break;
                        }
                    }
                }
            }
            reader_para.Close();
        Finish: ;
            return true;
        }

        /// <summary>
        /// プロジェクトファイルから構造定義ファイル名を抽出する
        /// </summary>
        /// <param name="file_project">プロジェクトファイル名</param>
        /// <returns></returns>
        public string pro_to_xmlfile(string file_project)
        {
            string file_xmlname="";


            System.Xml.XmlTextReader reader_pro = new System.Xml.XmlTextReader(file_project);
            while (reader_pro.Read())
            {
                reader_pro.MoveToContent();
                if (reader_pro.NodeType == System.Xml.XmlNodeType.Element)
                {
                    if (reader_pro.Name == "SCFile")
                    {
                        for (int i = 0; i < reader_pro.AttributeCount; i++)
                        {
                            reader_pro.MoveToAttribute(i);
                            if (reader_pro.Name == "FileName")
                            {
                                //xmlファイル取得
                                file_xmlname = (string)reader_pro.GetAttribute(i);
                            }
                        }
                    }
                }
            }
            reader_pro.Close();

            return file_xmlname;
        }

        //
        //all_elementname_number : Elementnameに含まれる番号(ない場合はNull)
        //component_line : 構造定義の<Component>の行番号
        //all_element_model_name : 演算モデル名
        
        /// <summary>
        /// ElementNameの番号順に書き換えるメソッド
        /// </summary>
        /// <param name="filename">読み込むファイルの名前</param>
        /// <param name="all_elementname_number">要素モデルの名称に含まれる番号</param>
        /// <param name="component_line">構造定義ファイル内の要素モデルの行番号の始めと終わりを順に格納</param>
        /// <param name="all_element_model_name">全ての要素モデル名</param>
        /// <param name="need_element_model_name">並び替えを行う要素モデル名</param>
        public void Alignment(string filename, ArrayList all_elementname_number, ArrayList component_line,
          ArrayList all_element_model_name, ArrayList need_element_model_name)
        {
            //対象ファイルを全てそのまま読み取る
            ArrayList buf = new ArrayList();
            string line;
            using (StreamReader r = new StreamReader(filename))
            {
                while ((line = r.ReadLine()) != null)
                {
                    buf.Add(line);
                }
                r.Close();
            }

            //buf_allには[モデル名, ElementNameの番号, CalElementの行番号(開始),CalElementの行番号(終了)]
            //を格納する.
            int count = all_elementname_number.Count;            

            if (count != component_line.Count / 2 || count != all_element_model_name.Count/2)
            {
                MessageBox.Show("Can't sort by number", "Error");
                goto Finish;
            }

            //出力&並び替え
            //ファイルの消去とComponentまでの出力
            string filename_out = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location) + "\\NewSCF.xml";

            
            if (File.Exists(filename_out))
            {
                File.Delete(filename_out);
            }
            using (StreamWriter w = new StreamWriter(filename_out, true, System.Text.Encoding.GetEncoding("UTF-8")))
            {
                int start_line = int.Parse(component_line[0].ToString());
                for(int i=0;i<start_line-1;i++)
                {
                    w.WriteLine(buf[i]);
                }
            }

            //Component部の並び替えと出力
            for (int i = 0; i < need_element_model_name.Count; i++)
            {
                ArrayList dummy = new ArrayList();
                for (int j = 0; j < count; j++)
                {           
                    if (need_element_model_name[i].ToString() == all_element_model_name[2 * j].ToString())
                    {
                        //要素モデル名が合致した時のみElementNameの番号,開始行番号,終了行番号を格納していく
                        dummy.Add(all_elementname_number[j]);
                        dummy.Add(component_line[2 * j]);
                        dummy.Add(component_line[2 * j+1]);
                    }
                }

                //並び替え
                bool check = false;
                while (check == false)
                {
                    check = true;
                    for (int j = 0; j < dummy.Count - 3; j += 3)
                    {
                        if (dummy[j].ToString() != "Null" && dummy[j + 3].ToString() != "Null")
                        {
                            if (int.Parse(dummy[j].ToString()) > int.Parse(dummy[j + 3].ToString()))
                            {
                                //もし前の数字が大きければ交換する
                                string dummy_1 = dummy[j].ToString();
                                string dummy_2 = dummy[j + 1].ToString();
                                string dummy_3 = dummy[j + 2].ToString();

                                dummy[j] = dummy[j + 3].ToString();
                                dummy[j + 1] = dummy[j + 4].ToString();
                                dummy[j + 2] = dummy[j + 5].ToString();

                                dummy[j + 3] = dummy_1;
                                dummy[j + 4] = dummy_2;
                                dummy[j + 5] = dummy_3;
                                check = false;
                            }
                        }
                    }
                }

                //出力
                using (StreamWriter w = new StreamWriter(filename_out, true,
    System.Text.Encoding.GetEncoding("UTF-8")))
                {
                    for (int j = 0; j < dummy.Count - 1; j += 3)
                    {
                        int start_line = int.Parse(dummy[j + 1].ToString());
                        int end_line = int.Parse(dummy[j + 2].ToString());

                        for (int k = start_line - 1; k < end_line; k++)
                        {
                            w.WriteLine(buf[k]);
                        }
                    }
                }
            }

            //Component以降の出力
            using (StreamWriter w = new StreamWriter(filename_out, true,
System.Text.Encoding.GetEncoding("UTF-8")))
            {
                int cl_count = component_line.Count;
                int end_line = int.Parse(component_line[cl_count-1].ToString());
                for (int i = end_line; i < buf.Count; i++)
                {
                    w.WriteLine(buf[i]);
                }
            }

            Finish: ;
        }

        public ArrayList Element_model_name
        {
            get
            {
                return need_element_model_name;
            }
            set
            {

                need_element_model_name = value;
            }
        }

        public ArrayList Shapekind_name
        {
            get
            {
                return need_shapeKind_name;
            }
            set
            {

                need_shapeKind_name = value;
            }
        }

        public ArrayList Component_Line
        {
            get
            {
                return component_line;
            }
            set
            {
                component_line = value;
            }
        }

        public ArrayList All_Elementname_Number
        {
            get
            {
                return all_elementname_number;
            }
            set
            {
                all_elementname_number = value;
            }
        }

        public ArrayList All_Element_Model_name
        {
            get
            {
                return all_element_model_name;
            }
            set
            {
                all_element_model_name = value;
            }
        }

        public ArrayList ALL_Para_name
        {
            get
            {
                return all_para_name;
            }
            set
            {
                all_para_name = value;
            }
        }
    }
}
