﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;
using System.Diagnostics;

namespace KyotoUnivEngHywrExecutionEnvironment
{
    public partial class Form1 : Form
    {
        string filename = "";
        string hymco_dir = "C:\\Program Files\\CommonMP\\Execute\\bin\\";//デフォルト
        ArrayList model_pass = new ArrayList();//モデル名&パラメタ数&パラメタ名を格納する      
        ArrayList element_model_name = new ArrayList();
        ArrayList shapeKind_name = new ArrayList();
        ArrayList pname = new ArrayList();
        string shapekeind_selected = "";

        /// <summary>
        /// メイン画面の管理を行う
        /// </summary>
        public Form1()
        {
            InitializeComponent();

            //Single_Calculateのチェックを最初に入れておく
            radioButton3.Checked = true;

            //"Ctrl + V"を押した時に起動
            dataGridView1.KeyDown += new KeyEventHandler(dataGridView1_KeyDown);

            //Form1のサイズ変更に伴う全体調整
            this.groupBox1.Anchor = AnchorStyles.Bottom|AnchorStyles.Left|AnchorStyles.Right|AnchorStyles.Top;
            this.dataGridView1.Anchor = AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            this.radioButton1.Anchor = AnchorStyles.Bottom | AnchorStyles.Left;
            this.radioButton2.Anchor = AnchorStyles.Bottom | AnchorStyles.Left;
            this.radioButton3.Anchor = AnchorStyles.Bottom | AnchorStyles.Left;
            this.Start_hymco.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;
        }

        /// <summary>
        /// ファイルの読み込み
        /// </summary>
        private void Open_File_ToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            //CommonMP\Execute\conf\HymcoCUI.cfgが存在する場合、
            //構造定義ファイルのディレクトリーここから読み取る
            string filename_cfg = "";
            if (Directory.Exists(hymco_dir) == true)
            {
                Directory.SetCurrentDirectory(hymco_dir);

                if (System.IO.File.Exists("../conf/HymcoCUI.cfg"))
                {
                    string line_cfg;
                    using (StreamReader read_cfg = new StreamReader("../conf/HymcoCUI.cfg"))
                    {
                        while ((line_cfg = read_cfg.ReadLine()) != null)
                        {
                            if (line_cfg.StartsWith("CUI_WORK_DIRECTORY")) break;
                        }
                    }

                    int dummy_cfg = line_cfg.Split('\t', '=').Count() - 1;
                    filename_cfg = (line_cfg.Split('\t', '=')[dummy_cfg]).Trim();
                    

                    openFileDialog2.InitialDirectory = filename_cfg;

                    using (StreamWriter w = new StreamWriter("memo.data"))
                    {
                        w.WriteLine(line_cfg);
                        w.WriteLine(filename_cfg);
                    }

                }
            }



            
            //OKボタンを押した時のみ作動
            if (openFileDialog2.ShowDialog() == DialogResult.OK)
            {
                //ファイル名の取得
                string filename_check = openFileDialog2.FileName;
                FileIO io = new FileIO();
                io.check_file(filename_check);
                element_model_name = io.Element_model_name;
                shapeKind_name = io.Shapekind_name;

                //構造定義ファイルを読み込んだかをチェック
                if (element_model_name.Count == 0 || shapeKind_name.Count == 0)
                {
                    MessageBox.Show("File Format is not correct","Error");
                    goto Finish;
                }

                //正しいファイルを読み取った場合、ファイル名を更新
                filename = filename_check;

                //Name of Element Modelの初期化
                comboBox1.Items.Clear();

                for (int i = 0; i < element_model_name.Count; i++)
                {
                    comboBox1.Items.Add(element_model_name[i]);
                }

                //初期値として一つモデル名を格納し、表にパラメタを格納           
                pname = io.ALL_Para_name;
                comboBox1.Text = element_model_name[0].ToString();
            }
        Finish: ;
        }

        /// <summary>
        /// hymco.exeを起動する
        /// </summary>
        private void button1_Click(object sender, EventArgs e)
        {
            //Multi_Calculateにチェックがある場合
            if (radioButton1.Checked)
            {
                //OKボタンを押した時のみ作動
                if (openFileDialog3.ShowDialog() == DialogResult.OK)
                {
                    string multi_filename = openFileDialog3.FileName;

                    Multi_Calculate multi = new Multi_Calculate();
                    multi.multi_calculate(multi_filename, hymco_dir);
                }
            }
            //Parameter_Identificationにチェックがある場合
            else if (radioButton2.Checked)
            {
                //ファイルを未読の場合反応しない
                if (filename == "")
                {
                    goto Finish;
                }

                //sce-uaに渡すパラメータ
                ArrayList x_value = new ArrayList();
                ArrayList para_info = new ArrayList();

                //パラメータの個数をグループ数のmaxとする
                int max_group = (int)model_pass[1] * (dataGridView1.Rows.Count - 1);
                string[] columns = new string[max_group];
                string[] rows = new string[max_group];

                //*は変更なしのため読み込まない
                bool check_group = false;
                for (int i = (int)model_pass[1]; i < dataGridView1.Columns.Count; i++)
                {
                    for (int j = 0; j < dataGridView1.Rows.Count - 1; j++)
                    {
                        if ((string)dataGridView1[i, j].Value != "*")
                        {
                            columns[int.Parse(dataGridView1[i, j].Value.ToString())] += (i - (int)model_pass[1]).ToString() + "\t";
                            rows[int.Parse(dataGridView1[i, j].Value.ToString())] += j.ToString() + "\t";
                            check_group = true;
                        }
                    }
                }

                if (check_group == false)
                {
                    MessageBox.Show("There is no group", "Error");
                    goto Finish;
                }

                int group_num = 0;
                while (columns[group_num] != null)
                {
                    int top_column = int.Parse(columns[group_num].Split('\t')[0]);
                    int top_row = int.Parse(rows[group_num].Split('\t')[0]);

                    x_value.Add(dataGridView1[top_column, top_row].Value);
                    para_info.Add(dataGridView1.Columns[top_column].HeaderText);
                    group_num++;
                }

                Parameter_Identification para_id = new Parameter_Identification();
                para_id.parameter_identify(x_value, para_info, hymco_dir, model_pass, dataGridView1, filename, columns, rows);
            }
            //Single_Calculateにチェックがある場合
            else
            {               
                if (filename_pro.Text.ToString().Length >0)
                {
                    //hymco.exeのディレクトリに移動
                    Directory.SetCurrentDirectory(hymco_dir);

                    //Projectnameの取得
                    string[] a = filename_pro.Text.Split('\\');
                    string filename = a[a.Count() - 1];

                    Process cmd_pro = new Process();
                    cmd_pro.StartInfo.FileName = "cmd.exe";
                    cmd_pro.StartInfo.Arguments = "/K" + "hymco.exe -c " + filename;
                    cmd_pro.Start();
                }
            }
            
        Finish: ;
            radioButton3.Checked = true;  
        }

        /// <summary>
        /// Ctrl + Vで貼り付け
        /// </summary>
        private void dataGridView1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            //セルが選択されていない時は[0,0]から貼り付けるようにする            
            int paste_c = 0;
            int paste_r = 0;

            //選択されているセルの中で左上にあるセル番号を抽出する[i,j]
            if(e.Control == true && e.KeyCode == Keys.V)
            {
                for (int i = 0; i < dataGridView1.RowCount; i++)
                {
                    for (int j = 0; j < dataGridView1.ColumnCount; j++)
                    {
                        if (dataGridView1[j, i].Selected == true)
                        {
                            paste_r = i;
                            paste_c = j;

                            goto Paste;                
                        }
                    }
                }

            Paste: ;

                string paste = " ";
                string[] word = {"\r\n"}; 
                paste = Clipboard.GetText();
                string[] values_r = paste.Split(word, StringSplitOptions.None);
                
                //(指定行+縦データ数)と貼り付け先の行数を比較
                int num_of_paste_r = dataGridView1.RowCount-1;
                if (paste_r + values_r.Count() < dataGridView1.RowCount)
                {
                    num_of_paste_r = paste_r + values_r.Count();
                }
                for (int i = paste_r; i < num_of_paste_r; i++)
                {
                    string[] values_c = values_r[i - paste_r].Split('\t',' ');
                    
                    //横データ数と貼り付け先の列数を比較
                    int num_of_paste_c = dataGridView1.ColumnCount;
                    if (paste_c + values_c.Count() < dataGridView1.ColumnCount)
                    {
                        num_of_paste_c = paste_c + values_c.Count();
                    }

                    for (int j = paste_c; j < num_of_paste_c; j++)
                    {
                        dataGridView1[j, i].Value = values_c[j - paste_c];
                    }
                }
            }
        }

        /// <summary>
        /// 上書き保存
        /// </summary>
        private void 上書き保存ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (filename != "")
            {
                try
                {
                    //ファイルの保存開始
                    FileIO io = new FileIO();
                    ArrayList buf_out = new ArrayList();
                    ArrayList buf_datagridview = new ArrayList();
                    buf_out = io.file_in(filename, 1, model_pass);
                    buf_datagridview = io.read_datagrid(dataGridView1, 0);
                    io.file_out(filename, filename, buf_out, buf_datagridview, model_pass);
                }
                catch
                {
                    MessageBox.Show("Can't Access the file","Error");
                }
            }
        }

        /// <summary>
        /// 名前をつけて保存
        /// </summary>
        private void Save_ToolStripMenuItem_Click(object sender, EventArgs e)
        { 
            //"filename"が更新されているかでファイルを読み込んでいるか判断する
            //OKボタンを押した時のみ作動
            if (filename != "" && saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //ファイル名の取得
                string filename_out = saveFileDialog1.FileName;

                //ファイルの保存開始
                try
                {
                    FileIO io = new FileIO();
                    ArrayList buf_out = new ArrayList();
                    ArrayList buf_datagridview = new ArrayList();
                    buf_out = io.file_in(filename, 1, model_pass);
                    buf_datagridview = io.read_datagrid(dataGridView1, 0);
                    io.file_out(filename, filename_out, buf_out, buf_datagridview, model_pass);

                    //ファイルの保存完了後、計算対象を変更する
                    filename_pro.Text = filename_out.Replace(".xml", "ProjectFile.xml");
                }
                catch
                {
                    MessageBox.Show("Can't Access the file", "Error");
                }
            }
        }

        /// <summary>
        /// hymco.exeのディレクトリ指定
        /// </summary>
        private void hymcoexeの設定ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //OKボタンを押した時のみ作動
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //hymco.exeが選ばれているかチェックする
                string a = openFileDialog1.FileName;
                string[] b = a.Split('\\');
                if (b[b.Count() - 1] == "hymco.exe")
                {
                    hymco_dir = "";
                    for (int i = 0; i < b.Count() - 1; i++)
                    {
                        hymco_dir += b[i] + "\\";
                    }                                              
                }
                else
                {
                    MessageBox.Show("Please select hymco.exe", "Error");
                }
            }
        }

        /// <summary>
        /// プログラムを閉じる
        /// </summary>
        private void 閉じるToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        /// <summary>
        /// 要素モデル名の変更
        /// </summary>
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ラジオボタンをデフォルト状態に戻す
            radioButton3.Checked = true;

            //選択された要素モデルが"Basin","Output","Input"かで動作を変える
            int select_num=0;

            for (int i = 0; i < element_model_name.Count; i++)
            {
                if (element_model_name[i].ToString() == comboBox1.Text)
                {
                    select_num = i;
                }
            }

            shapekeind_selected = shapeKind_name[select_num].ToString();

            //model_passに新しく、要素モデル名とパラメータ数、パラメータの名前を格納する
            model_pass.Clear();
            model_pass.Add(comboBox1.Text);                                                //model_pass[0]に要素モデル名を格納

            int pn_count = ((ArrayList)pname[select_num]).Count;
            string[] para_name = new string[pn_count];
            for (int i = 0; i < pn_count; i++)
            {
                para_name[i] = ((ArrayList)pname[select_num])[i].ToString();
            }

            model_pass.Add(para_name.Count());
            for (int i = 0; i < para_name.Count(); i++) 
            {
                model_pass.Add(para_name[i]);                　  //model_pass[2]以降にパラメータの名前を格納
            }

            //表の初期化
            int count_column = dataGridView1.Columns.Count;
            for (int i = 0; i < count_column; i++)
            {
                dataGridView1.Columns.RemoveAt(0);
            }        

            //パラメータ名の表示
            for (int i = 0; i < para_name.Count(); i++)
            {
                dataGridView1.Columns.Add("newcol", model_pass[2 + i].ToString());
            }

            //パラメータ値の読み込みと格納
            ArrayList buf_para = new ArrayList();
            FileIO io = new FileIO();
            buf_para = io.file_in(filename, 0, model_pass);

            int one_step_count = model_pass.Count;
            int number_of_steps = buf_para.Count / model_pass.Count;

            for (int i = 0; i < number_of_steps; i++)
            {
                DataGridViewRow dgvr = new DataGridViewRow();
                dgvr.CreateCells(dataGridView1);
                dgvr.HeaderCell.Value = buf_para[0 + i * one_step_count]
                    + "(" + buf_para[1 + i * one_step_count] + ")";

                //パラメータ値を表に格納する
                for (int j = 2; j < one_step_count; j++)
                {
                    dgvr.Cells[j - 2].Value = buf_para[j + i * one_step_count].ToString();
                }
                dataGridView1.Rows.Add(dgvr);
            }

            //Size調整 (調整する必要あり)
            dataGridView1.RowHeadersWidth = ((string)buf_para[0]).Length * 8 + ((string)buf_para[1]).Length*3 + 40;

            //ProjectFileの表示
            //フルパスで表示
            string a = filename.Replace(".xml", "ProjectFile.xml");
            filename_pro.Text = filename.Replace(".xml", "ProjectFile.xml");

            //最下行をReadOnlyにする
            //パラメータの種類数はmodel_pass.Count - 2個
            for (int i = 0; i < (int)model_pass[1]; i++)
            {
                dataGridView1[i, number_of_steps].ReadOnly = true;
            }
        }

        /// <summary>
        /// ラジオボタン1をチェックした時の挙動
        /// </summary>
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                filename_pro.ReadOnly = true;

                //セルの色を灰色にする
                for (int i = 0; i < dataGridView1.ColumnCount; i++)
                {
                    for (int j = 0; j < dataGridView1.RowCount; j++)
                    {
                        dataGridView1[i, j].Style.BackColor = Color.Gray;
                    }
                }
                dataGridView1.ReadOnly = true;
                comboBox1.Enabled = false;
            }
            else
            {               
                filename_pro.ReadOnly = false;

                //セルの色を白色にする
                for (int i = 0; i < dataGridView1.ColumnCount; i++)
                {
                    for (int j = 0; j < dataGridView1.RowCount; j++)
                    {
                        dataGridView1[i, j].Style.BackColor = Color.Empty;
                    }
                }
                dataGridView1.ReadOnly = false;
                comboBox1.Enabled = true;
            }
        }

        /// <summary>
        /// ラジオボタン2をチェックした時の挙動
        /// </summary>
        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (filename != "" && shapekeind_selected == "Basin")
            {
                if (radioButton2.Checked)
                {
                    for (int i = 0; i < (int)model_pass[1]; i++)
                    {
                        dataGridView1.Columns.Add("newcol", model_pass[2 + i].ToString());
                    }

                    for (int i = (int)model_pass[1]; i < (int)model_pass[1] * 2; i++)
                    {
                        for (int j = 0; j < dataGridView1.Rows.Count - 1; j++)
                        {
                            dataGridView1[i, j].Value = "*";
                        }
                    }

                    //最下行をReadOnlyにする
                    for (int i = (int)model_pass[1]; i < (int)model_pass[1] * 2; i++)
                    {
                        dataGridView1[i, dataGridView1.Rows.Count-1].ReadOnly = true;
                    }
                }
                else
                {
                    for (int i = 0; i < (int)model_pass[1]; i++)
                    {
                        dataGridView1.Columns.RemoveAt((int)model_pass[1]);
                    }
                }
            }
            else
            {
                radioButton2.Checked = false;
                radioButton3.Checked = true;
            }
        }

        /// <summary>
        /// モデル並び替え
        /// </summary>
        private void モデル並び替えToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //OKボタンを押した時のみ作動
            if (openFileDialog4.ShowDialog() == DialogResult.OK)
            {
                //ファイル名の取得
                filename = openFileDialog4.FileName;
                
                FileIO io = new FileIO();
                io.check_file(filename);

                ArrayList all_elementname_number = new ArrayList();
                ArrayList component_line = new ArrayList();
                ArrayList all_element_model_name = new ArrayList();
                ArrayList need_element_model_name = new ArrayList();
                
                all_elementname_number = io.All_Elementname_Number;
                component_line = io.Component_Line;
                all_element_model_name = io.All_Element_Model_name;
                need_element_model_name = io.Element_model_name;

                //並び替えメソッド呼び出し
                io.Alignment(filename, all_elementname_number, component_line, all_element_model_name,
                    need_element_model_name);

                //終了を知らせる
                MessageBox.Show("Finish", "Message");
            }
        }
    }
}
