﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace KyotoUnivEngHywrExecutionEnvironment
{
    public partial class Form2 : Form
    {            
        bool check = false;
        string filename_cal="";
        string filename_obs="";
        string model_name = "";
        ArrayList element_name = new ArrayList();
        ArrayList para_name = new ArrayList();

        /// <summary>
        /// パラメタ同定画面の管理を行う
        /// </summary>
        /// <param name="x_value">パラメタ値</param>
        /// <param name="para_info">パラメタ名など</param>
        public Form2(ArrayList x_value, ArrayList para_info)
        {
            InitializeComponent();

            //"Ctrl + V"を押した時に起動  
            dataGridView1.KeyDown += new KeyEventHandler(dataGridView1_KeyDown);

            //para_nameを要素モデル名とElementNameに分解する
            model_name = (para_info[0].ToString().Split('(', ')'))[0];

            //ElementNameと値を表示
            for (int i = 0; i < x_value.Count; i++)
            {
                DataGridViewRow dgvr = new DataGridViewRow();
                dgvr.CreateCells(dataGridView1);
                dgvr.HeaderCell.Value = "No." + i + " Group (" + para_info[i] + ")";

                dataGridView1.Rows.Add(dgvr);

                for (int j = 0; j < 3; j++)
                {
                    dataGridView1[j, i].Value = x_value[i];
                }
            }

            dataGridView1.RowHeadersWidth = 280;

            //Object functionなどの初期設定
            comboBox1.Text = "Nash指標";
            comboBox2.Text = "s";
            checkBox1.Checked = true;

            //Form3のサイズ変更に伴う全体調整
            groupBox1.Anchor = AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            dataGridView1.Anchor = AnchorStyles.Bottom|AnchorStyles.Left|AnchorStyles.Right|AnchorStyles.Top;
            label1.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            textBox1.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            Observe_datafile.Anchor = AnchorStyles.Left | AnchorStyles.Bottom;
            Calculate_datafile.Anchor = AnchorStyles.Left | AnchorStyles.Bottom;
            textBox2.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
            textBox3.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
            button1.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            button2.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            groupBox2.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            label2.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            label3.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            comboBox1.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            comboBox2.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            checkBox1.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            button3.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
        }

        int cal_count = 0;
        /// <summary>
        /// パラメタ設定完了を調べる
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OK_Click(object sender, EventArgs e)
        {
            //「×」を押した場合に計算を止めるために、
            //OKボタンを押した時点でcheck=trueとする。
            check = true;         
            try
            {
                cal_count = int.Parse(textBox1.Text);
            }
            catch
            {
                MessageBox.Show("Please input calclate_number", "Error");
                goto Finish;
            }


            //値が格納されているチェックする
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                for (int j = 0; j < dataGridView1.Columns.Count; j++)
                {
                    if (dataGridView1[j, i].Value == null)
                    {
                        check = false;
                        MessageBox.Show("Please fill in the all cells", "Error");
                        goto Finish;                    
                    }
                }
            }

            //minmum <= initial <= maximumをチェックする
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (double.Parse(dataGridView1[0, i].Value.ToString()) > double.Parse(dataGridView1[1, i].Value.ToString()))
                {
                    check = false;
                    MessageBox.Show("Please minimum <= initial <= maximum", "Error");
                    goto Finish;
                }
                if (double.Parse(dataGridView1[1, i].Value.ToString()) > double.Parse(dataGridView1[2, i].Value.ToString()))
                {
                    check = false;
                    MessageBox.Show("Please minimum <= initial <= maximum", "Error");
                    goto Finish;
                }
            }
           
            //ファイルの読み込みを確認
            if (filename_cal == "" || filename_obs == "")
            {
                check = false;
                MessageBox.Show("Please input filename", "Error");
                goto Finish;
            }

            //チェックを通ったらForm3を消す
            if (check == true)
            {
                Close();
            }
        Finish: ;
        }

        public ArrayList Minimum_data()
        {
            ArrayList x_min = new ArrayList();
            for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
            {
                x_min.Add(dataGridView1[0, i].Value);
            }
            return x_min;
        }

        public ArrayList Initial_data()
        {
            ArrayList x_init = new ArrayList();
            for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
            {
                x_init.Add(dataGridView1[1, i].Value);
            }
            return x_init;
        }

        public ArrayList Maximum_data()
        {
            ArrayList x_max = new ArrayList();
            for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
            {
                x_max.Add(dataGridView1[2, i].Value);
            }
            return x_max;
        }

        /// <summary>
        /// 出力ファイル名の参照
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            //OKボタンを押した時のみ作動
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename_cal = openFileDialog1.FileName;
                textBox2.Text = filename_cal;
            }
        }

        /// <summary>
        /// 観測値ファイル名の参照
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            //OKボタンを押した時のみ作動
            if (openFileDialog2.ShowDialog() == DialogResult.OK)
            {
                filename_obs = openFileDialog2.FileName;
                textBox3.Text = filename_obs;
            }
        }

        /// <summary>
        /// Ctrl + Vで貼り付け
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            //セルが選択されていない時は[0,0]から貼り付けるようにする            
            int paste_c = 0;
            int paste_r = 0;

            //選択されているセルの中で左上にあるセル番号を抽出する[i,j]
            if (e.Control == true && e.KeyCode == Keys.V)
            {
                for (int i = 0; i < dataGridView1.RowCount; i++)
                {
                    for (int j = 0; j < dataGridView1.ColumnCount; j++)
                    {
                        if (dataGridView1[j, i].Selected == true)
                        {
                            paste_r = i;
                            paste_c = j;

                            goto Paste;
                        }
                    }
                }

            Paste: ;

                string paste = " ";
                paste = Clipboard.GetText();
                string[] values_r = paste.Split('\n');

                //(指定行+縦データ数)と貼り付け先の行数を比較
                int num_of_paste_r = dataGridView1.RowCount;
                if (paste_r + values_r.Count() < dataGridView1.RowCount)
                {
                    num_of_paste_r = paste_r + values_r.Count();
                }
                for (int i = paste_r; i < num_of_paste_r; i++)
                {
                    string[] values_c = values_r[i - paste_r].Split('\t');

                    //横データ数と貼り付け先の列数を比較
                    int num_of_paste_c = dataGridView1.ColumnCount;
                    if (paste_c + values_c.Count() < dataGridView1.ColumnCount)
                    {
                        num_of_paste_c = paste_c + values_c.Count();
                    }

                    for (int j = paste_c; j < num_of_paste_c; j++)
                    {
                        dataGridView1[j, i].Value = values_c[j - paste_c];
                    }
                }
            }
        }

        public bool check_ok
        {
            get
            {
                return check;
            }

            set
            {
                check = value;
            }
        }

        public int Cal_count
        {
            get
            {
                return cal_count;
            }

            set
            {
                cal_count = value;
            }
        }

        public string Filename_of_cal
        {
            get
            {
                return filename_cal;
            }
            set
            {
                filename_cal = value;
            }
        }

        public string Filename_of_obs
        {
            get
            {
                return filename_obs;
            }
            set
            {
                filename_obs = value;
            }
        }

        public string Modelname
        {
            get
            {
                return model_name;
            }
            set
            {

                model_name = value;
            }
        }

        public ArrayList Elname
        {
            get
            {
                return element_name;
            }
            set
            {

                element_name = value;
            }
        }

        public ArrayList Paname
        {
            get
            {
                return para_name;
            }
            set
            {

                para_name = value;
            }
        }

        public string Ob_func
        {
            get
            {
                return comboBox1.Text;
            }
            set
            {

                comboBox1.Text = value;
            }
        }

        public string Time_type
        {
            get
            {
                return comboBox2.Text;
            }
            set
            {

                comboBox2.Text = value;
            }
        }

        public bool Check_out
        {
            get
            {
                return checkBox1.Checked;
            }
            set
            {

                checkBox1.Checked = value;
            }
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void openFileDialog2_FileOk(object sender, CancelEventArgs e)
        {

        }
    }
}
