﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;
using System.Threading;

namespace KyotoUnivEngHywrExecutionEnvironment
{
    public partial class Form3 : Form
    {
        ArrayList out_put = new ArrayList(); // 目的関数値とパラメータ値を格納する
        double best_value = 0.0;
        int best_count = 0;
   
        public Form3()
        {
            //listBox1.Items.Clear();
            InitializeComponent();
        }

        // 文字のみの場合のテキスト画面出力
        public void textDisplay0(string list)
        {
            //listBox1.Items.Add(list); // item ボックスによる追加表示 
            //textBox1.Text = list;     // text ボックスによる一行表示

            out_put.Add(list);  // 文字列をリストに追加する

            textBox1.Text += list;     // text ボックスによる追加表示
            textBox1.Text += "\r\n";   // text ボックス改行
            //textBox1.Refresh();        // text ボックス更新
            textBox1.Update();         // text ボックス更新
            textBox1.Select(textBox1.Text.Length, 0); // キャレットをテキストの一番最後に移動させます。
            textBox1.ScrollToCaret(); // キャレットがテキストボックスの見える位置にくるようにテキストボックスをスクロール
        }

        // 数字を整理する場合
        public void textDisplay1(string list)
        {
            // list は"解析番号、目的関数結果、パラメータ値群、解析番号"が入っている。
            // 空白で区切ったのちに、""を除外し、list_sep に入れる。
            string[] list_sep_dummy = list.Split(' ');
            ArrayList list_sep = new ArrayList();          
            for (int i = 0; i < list_sep_dummy.Count(); i++)
            {
                if (list_sep_dummy[i] != "")
                {
                    list_sep.Add(list_sep_dummy[i]);
                }
            }
            string list_new = "";

            //スペース5つ分に解析番号を格納していく
            for (int i = 0; i < 6 - list_sep[0].ToString().Length; i++)
            {
                list_new += " ";
            }

            list_new += list_sep[0].ToString();

            // 目的関数結果を格納
            for (int i = 0; i < 11 - list_sep[1].ToString().IndexOf('.'); i++)
            {
                list_new += " ";
            }

            list_new += list_sep[1].ToString();

            for (int i = 0; i < 20 - list_sep[1].ToString().Length; i++)
            {
                list_new += " ";
            }

            //パラメータ値群を格納
            for (int i = 2; i < list_sep.Count - 1; i++)
            {
                int space_count_t = list_sep[i].ToString().IndexOf(".");
                int space_count_b = list_sep[i].ToString().Length - space_count_t;

                if (space_count_t == -1)
                {
                    space_count_t = list_sep[i].ToString().Length;
                    space_count_b = 0;
                }
                for (int j = 0; j < 7 - space_count_t; j++)
                {
                    list_new += " ";
                }
                
                list_new += list_sep[i];

                for (int j = 0; j < 12 - space_count_b; j++)
                {
                    list_new += " ";
                }
            }

            //listBox1.Items.Add(list_new); // item ボックスによる追加表示 
            //textBox1.Text = list_new;     // text ボックスによる一行表示 

            out_put.Add(list_new);  // 目的関数値とパラメータ値をリストに追加する

            textBox1.Text += list_new;  // text ボックスによる追加表示
            textBox1.Text += "\r\n";    // text ボックス改行
            //textBox1.Refresh();       // text ボックス更新
            textBox1.Update();          // text ボックス更新
            textBox1.Select(textBox1.Text.Length, 0); // キャレットをテキストの一番最後に移動させます。
            textBox1.ScrollToCaret(); // キャレットがテキストボックスの見える位置にくるようにテキストボックスをスクロール
        }

        public void best(double ev, int count) // ev の最大値を求める
        {
            if (best_value < ev)
            {
                best_value = ev;
                best_count = count;
            }
        }

        /// <summary>
        /// パラメタ同定の結果をファイルに出力する
        /// </summary>
        /// <param name="dataGridView1">メイン画面のパラメタ表</param>
        /// <param name="columns">グループ番号が設定されている列番号</param>
        /// <param name="rows">グループ番号が設定されている行番号</param>
        /// <param name="ob_func">目的関数名</param>
        public void fileOutput(DataGridView dataGridView1, string[] columns, string[] rows, string ob_func)
        {
            using (StreamWriter write_list = new StreamWriter("cmpeeParamCalibResult.dat"))
            {
                write_list.WriteLine("Objective Function is '" + ob_func + "'");
                //パラメータ名表記
                for (int i = 0; i < columns.Count(); i++)
                {
                    if (columns[i] != null)
                    {
                        string[] sepa_column = columns[i].Split('\t');
                        string[] sepa_rows = rows[i].Split('\t');
                        string out_parameter_name =dataGridView1.Columns[int.Parse(sepa_column[0])].HeaderText + "//" ;
                        for (int j = 0; j < sepa_column.Count() - 1; j++)
                        {
                            out_parameter_name += dataGridView1.Rows[int.Parse(sepa_rows[j])].HeaderCell.Value + "  ";
                        }
                        write_list.WriteLine("Group" + i + ": " + out_parameter_name);
                    }
                }
                
                //目的関数の値を出力
                for (int i = 0; i < out_put.Count; i++)
                {
                    if (i == best_count+2) // 最初の2行はデータの説明が入るため 2 足す。
                    {
                        write_list.WriteLine(out_put[i] + "     *"); // 最適値には * をつける
                    }
                    else
                    {
                        write_list.WriteLine(out_put[i]);
                    }
                }
                write_list.Close();
            }
        }

        /// <summary>
        /// 閉じる
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
