﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;
using System.Diagnostics;

namespace KyotoUnivEngHywrExecutionEnvironment
{
    class Multi_Calculate
    {
        //計算後のログ出力用
        ArrayList multi_log = new ArrayList();


        /// <summary>
        /// Multi_Calculateの本体
        /// </summary>
        /// <param name="file_data">パラメタ変更などが描かれたファイル名</param>
        /// <param name="hymco_dir">hymco.exeのディレクトリ</param>
        public void multi_calculate(string file_data, string hymco_dir)
        {
            //Multi_Calculate.dataの読み込み(全て格納⇒振り分け)       　　
            //ファイルの存在確認
            if (System.IO.File.Exists(file_data) == false)
            {
                MessageBox.Show("There is not a Data file ", "Error");
                goto Finish;
            }

            //全て格納
            ArrayList buf_all = new ArrayList();
            string line_data;
            string file_project;

            using (StreamReader read_data = new StreamReader(file_data, System.Text.Encoding.GetEncoding("shift_jis")))
            {
                while ((line_data = read_data.ReadLine()) != null)
                {
                    if (line_data.Length > 0)
                    {
                        if (line_data[0] != '#' && line_data[0] != '\n' && line_data[0] != ' ')
                        {
                            buf_all.Add(line_data);
                        }
                    }
                }
            }


            //計算回数を求める
            int start_count = 0;
            int end_count = 0;
            for (int i = 0; i < buf_all.Count; i++)
            {
                if ((string)buf_all[i] == "[Calculate_start]")
                {
                    start_count++;
                }
                else if((string)buf_all[i] == "[Calculate_end]")
                {
                    end_count++;
                }
            }
            if (start_count != end_count)
            {
                MessageBox.Show("Numbers of start and end are difference", "DataError");
                goto Finish;
            }

            //パラメータ更新と解析
            int error_no = 0;

            try
            {
                for (int i = 0; i < start_count; i++)
                {
                    //計算回数の更新
                    error_no++;
           
                    //解析1回分を抽出する
                    ArrayList buf_one = new ArrayList();
                    int count_calstart = -1;
                    for (int j = 0; j < buf_all.Count; j++)
                    {
                        //抽出すべき個所を探す
                        if (buf_all[j].ToString() == "[Calculate_start]")
                        {
                            count_calstart++;
                        }

                        //格納
                        if (count_calstart == i)
                        {
                            buf_one.Add(buf_all[j]);
                        }
                        else if (count_calstart == i + 1)
                        {
                            break;
                        }
                    }
                    //パラメータとディレックトリーの更新
                    bool xml_check = false;
                    string[] dummy_multi_filename;
                    string filename = "";
                    string multi_filename = "";

                    //model_pass作成の準備
                    ArrayList model_pass = new ArrayList();
                    ArrayList element_model_name = new ArrayList();
                    ArrayList pname = new ArrayList();
                    FileIO io = new FileIO();
                    
                    for (int j = 0; j < buf_one.Count; j++)
                    {
                        
                        //[Xml_Directry]の確認、ProjectFileの読み込みと存在確認
                        if (buf_one[1].ToString() == "[Xml_Directry]" && xml_check == false)
                        {
                            file_project = buf_one[2].ToString();

                            //Multi_Calculate.xmlのフルパス設定
                            dummy_multi_filename = file_project.Split('\\', '/');
                            int dummy_count = dummy_multi_filename.Count() - 1;
                            multi_filename = file_project.Replace(dummy_multi_filename[dummy_count], "Multi_Calculate.xml");

                            //filenameの読み取りとパスを追加する
                            filename = io.pro_to_xmlfile(file_project);
                            filename = file_project.Replace(dummy_multi_filename[dummy_count], filename);

                            io.check_file(filename);
                            element_model_name = io.Element_model_name;
                            pname = io.ALL_Para_name;

                            if (File.Exists(file_project) == false)
                            {
                                MessageBox.Show("There is not a ProjectFile", "DataError");
                                goto Finish;
                            }

                            xml_check = true;
                        }
                        else if (buf_one[1].ToString() != "[Xml_Directry]")
                        {
                            MessageBox.Show("There is not Xml_Directry in Datafile", "DataError");
                            goto Finish;
                        }

                        //パラメータの更新
                        model_pass.Clear();
                        if (buf_one[j].ToString() == "[Model_name_of_parameter]")
                        {
                            //model_pass作成
                            int select_num = 0;
                            string multi_model_name = buf_one[j + 1].ToString();

                            for (int k = 0; k < element_model_name.Count; k++)
                            {
                                if (element_model_name[k].ToString() == multi_model_name)
                                {
                                    select_num = k;
                                }
                            }

                            model_pass.Add(multi_model_name); //model_pass[0]に要素モデル名を格納
                            model_pass.Add(((ArrayList)pname[select_num]).Count); //model_pass[1]にパラメータの数を格納

                            for (int k = 0; k < ((ArrayList)pname[select_num]).Count; k++)
                            {
                                model_pass.Add(((ArrayList)pname[select_num])[k]); //model_pass[2]以降にパラメータの名前を格納
                            }

                            //パラメータ値読み込み
                            ArrayList buf_data = new ArrayList();
                            int count = 0;
                            while (buf_one[j + 3 + count].ToString().ToCharArray()[0] != '[')
                            {
                                string[] para_line = buf_one[j + 3 + count].ToString().Split(' ', '\t');
                                for (int l = 0; l < para_line.Count(); l++)
                                {
                                    buf_data.Add(para_line[l]);
                                }
                                count++;
                            }

                            //パラメータ値を変更
                            ArrayList buf_out = new ArrayList();
                            buf_out = io.file_in(filename, 1, model_pass);
                            io.file_out(filename, multi_filename, buf_out, buf_data, model_pass);

                            //filenameを更新
                            filename = multi_filename;
                        }
                        //Outputのディレクトリー変更
                        else if (buf_one[j].ToString() == "[Output_Directry_Change]")
                        {
                            //model_pass作成
                            int select_num = 0;
                            string multi_model_name = buf_one[j + 1].ToString();

                            //構造定義ファイル内で何種類目の要素モデルかを割り出す
                            for (int k = 0; k < element_model_name.Count; k++)
                            {
                                if (element_model_name[k].ToString() == multi_model_name)
                                {
                                    select_num = k;
                                }
                            }

                            //[Output_Directry_Change]の後に情報がない場合は次へ行く
                            for (int k = 1; k < 4; k++)
                            {
                                if (buf_one[j + k].ToString().StartsWith("["))
                                {
                                    goto Finish_onestep;
                                }
                            }

                            model_pass.Add(multi_model_name);                                                   //model_pass[0]に要素モデル名を格納
                            model_pass.Add(((ArrayList)pname[select_num]).Count);                 //model_pass[1]にパラメータの数を格納(最後に""があるため-1をする)
                            model_pass.Add(buf_one[j + 2]);                                                     //model_pass[2]にKey名を格納
  
                            //buf_outの格納
                            ArrayList buf_out = new ArrayList();
                            buf_out = io.file_in(filename, 2, model_pass);

                            //Directry作成
                            string directry_name = buf_one[j + 3].ToString().Replace("*", "");
                            Directory.CreateDirectory(directry_name);

                            //Directry名を格納
                            ArrayList buf_data = new ArrayList();
                            for (int k = 0; k < buf_out.Count / 2; k++)
                            {
                                buf_data.Add(directry_name);
                            }
                            io.file_out(filename, multi_filename, buf_out, buf_data, model_pass);
                        }
                        //Inputのディレクトリー変更
                        else if (buf_one[j].ToString() == "[Input_Directry_Change]")
                        {
                            //model_pass作成
                            int select_num = 0;
                            string multi_model_name = buf_one[j + 1].ToString();

                            for (int k = 0; k < element_model_name.Count; k++)
                            {
                                if (element_model_name[k].ToString() == multi_model_name)
                                {
                                    select_num = k;
                                }
                            }

                            //[Input_Directry_Change]の後に情報がない場合は次へ行く
                            for (int k = 1; k < 4; k++)
                            {
                                if (buf_one[j + k].ToString().StartsWith("["))
                                {
                                    goto Finish_onestep;
                                }
                            }

                            model_pass.Add(multi_model_name);                                                   //model_pass[0]に要素モデル名を格納
                            model_pass.Add(((ArrayList)pname[select_num]).Count);                 //model_pass[1]にパラメータの数を格納(最後に""があるため-1をする)
                            model_pass.Add(buf_one[j + 2]);                                                     //model_pass[2]にKey名を格納

                            //buf_outの格納
                            ArrayList buf_out = new ArrayList();
                            buf_out = io.file_in(filename, 2, model_pass);

                            //Directry名を格納
                            ArrayList buf_data = new ArrayList();

                            for (int k = 0; k < buf_out.Count / 2; k++)
                            {
                                buf_data.Add(buf_one[j + 3].ToString().Replace("*", ""));
                            }
                            io.file_out(filename, multi_filename, buf_out, buf_data, model_pass);
                        }
                    Finish_onestep: ;
                    }
                    
                    //解析            
                    Directory.SetCurrentDirectory(hymco_dir);
                    Process cmd_pro = new Process();
                    cmd_pro.StartInfo.FileName = "cmd.exe";
                    cmd_pro.StartInfo.Arguments = "/K " + "hymco.exe -c Multi_CalculateProjectFile.xml";

                    cmd_pro.StartInfo.UseShellExecute = false;
                    cmd_pro.StartInfo.CreateNoWindow = true;
                    cmd_pro.StartInfo.RedirectStandardOutput = true;

                    cmd_pro.Start();
                    
                    //コマンドプロンプトが作動している間はここで止めておく
                    string resulting = cmd_pro.StandardOutput.ReadToEnd();
                    while (resulting != null)
                    {
                        multi_log.Add(resulting);

                        resulting = resulting.Replace("\r\r\n", "\n");
                        Debug.Listeners.Add(new TextWriterTraceListener(Console.Out));
                        //Debug.WriteLine("abc");

                        resulting = cmd_pro.StandardOutput.ReadLine();
                    }

                    //計算終了後コマンドプロンプトを消す
                    if (cmd_pro.HasExited == false)
                    {
                        cmd_pro.Kill();
                        cmd_pro.Close();
                        cmd_pro.Dispose();
                    }

                    //念のためにbuf_oneをクリアする
                    buf_one.Clear();
                }
            }
            catch (InvalidCastException e) 
            {
                MessageBox.Show("Calculate No." + error_no.ToString() +" have some errors", "Error");
                MessageBox.Show(e.ToString(), "Error");
            }

            //ログの出力
            using (StreamWriter write_log = new StreamWriter("multi_log.txt"))
            {
                for (int j = 0; j < multi_log.Count; j++)
                {
                    write_log.WriteLine(multi_log[j]);
                }
                write_log.Close();
            }

            MessageBox.Show("Multi_Caliculate Finishes", "End Message");

        Finish: ;
        }
    }
}
